/*!

	\file eef_log.h
	\brief API of the Nextgen logging functions
	\author Aram Verstegen

	This header contains the declarations of the EEF library functions:
	-# eef_log(int priority, char* format_string, va_args data): Logs string to syslog with a given priority, which are printed to stdout or stderr depending on their priority, and always to syslog.
*/

#ifndef EEF_LOG_H
#define EEF_LOG_H
#include <syslog.h>
#include <string.h>
#include "eef_return_codes.h"

extern void (*EEF_log)(int, const char*, ...);

#endif
