#ifndef EEF_PLUGINDL_S
#define EEF_PLUGINDL_S
#if HAVE_CONFIG_H
#include "config.h"
#endif

#if HAVE_STDIO_H
#include <stdio.h>
#endif
#if HAVE_LINUX_LIMITS_H
#include <linux/limits.h>
#else
#if HAVE_SYS_PARAM_H
/* most bsd's */
#include <sys/param.h>
#endif
#endif

#ifndef ARG_MAX
#define ARG_MAX 4096
#endif

#define MAXPROCS                5
#define LCMAPS_MAXARGSTRING     2000
typedef void *eef_proc_t;

/*!
 * \brief Node structure to hold plugin nodes
 */
typedef struct eef_plugindl_s
{
    void *                     handle;                          /*!< dlopen handle to plugin module */
    eef_proc_t                 procs[MAXPROCS];                 /*!< list of handles to interface functions of plugin */
    char                       name[FILENAME_MAX];              /*!< name of plugin */
    char                       args[LCMAPS_MAXARGSTRING];       /*!< argument string */
    int                        init_argc;                       /*!< number of arguments for the initialization function */
    char *                     init_argv[ARG_MAX];              /*!< list of arguments for the initialization function */
    struct eef_plugindl_s *    next;                            /*!< pointer to the next plugin in the plugin list */
} eef_plugindl_t;

#endif
