#include <stdio.h>
/* Include libeef/eef_plugin.h */
#include "eef_plugin.h"

/* Constructor for the plugin, called by the libeef plugin manager */
EES_PL_RC plugin_initialize(int argc, char* argv[]) {
	/* Log to unified logger in libeef, using normal syslog loglevels */
	EEF_log(LOG_DEBUG, "Initializing plugin ees_dummy_obligations!\n");
	/* Return with successful plugin return code */
	return EES_PL_SUCCESS;
}

/* Main for the plugin, called by the libeef plugin manager */
EES_PL_RC plugin_run(void) {
  int               i               = 10;   /* Number of Obligation created */
  aos_context_t    *_context        = NULL; /* Pointer to the aos_context_t container of attributes */
  aos_attribute_t  *_tmp_attr       = NULL; /* Pointer to the temporary aos_attribute_t node */
  while(i){
    /* Create a new obligation */
    EEF_log(LOG_DEBUG, "Creating obligation\n");
    if((_context = createContext(OBLIGATION)) != NULL) {   
      /* Set its identifier */
      setContextObligationId(_context, "my_obligation");
      /* Create a temporary attribute  _tmp_attr */
      if((_tmp_attr = createAttribute())) {
          /* Set its identifier and value */
          setAttributeId(   _tmp_attr, "attrib_id");
          setAttributeValue(_tmp_attr, "attrib_value", strlen("attrib_value")+1);
      }

      EEF_log(LOG_DEBUG, "Adding dummy attribute %p to context at %p\n", _tmp_attr, _context);
      /* Add the created attribute _tmp_attr to the context held by _context */
      addAttribute(_context, _tmp_attr);
      /* Add the created context to the AOS for retrieval by other plugins */
      addContext(_context);
    }
    i--;
  }
  /* Return with successful plugin return code */
  return EES_PL_SUCCESS;
}

/* Destructor for the plugin, called by the libeef plugin manager */
EES_PL_RC plugin_terminate(void) {
	/* Return with successful plugin return code */
  return EES_PL_SUCCESS;
}
