#ifndef IMAGE_MAP_FILE_H
#define IMAGE_MAP_FILE_H

#define MATCH_NO_WILD_CHARS       ((unsigned short)0x0000)
#define MATCH_WILD_CHARS          ((unsigned short)0x0002)

typedef struct _charlist {
  char             * value;
  struct _charlist * next;
} charlist_t;


typedef struct _gridmap_line_s {
	char       * match;
	charlist_t * mappings;
} gridmap_line_t;

typedef struct _gridmap_list {
	gridmap_line_t       * line;
	struct _gridmap_list * next;
} gridmap_list_t;

void gridmap_list_free(gridmap_list_t * list);
int parse_gridmapfile(const char * image_map_file, gridmap_list_t ** list);
gridmap_line_t * find_mapping(const gridmap_list_t * list, const char * to_match, unsigned short matching_type);

/**
 *adding a string to the list and the list will become the onwer of the string so do not free it manually
 *@return would return NULL if the machine is out of memory
 */
charlist_t * charlist_add_char_ptr_own(charlist_t * list, const char * str);

/**
 *adding a string that is owned by someone else to the list, this will force to copy the stinrg
 *@param list the current list. Could be NULL to create a list
 *@param the string to copy and add
 *@return the list of chars, NULL if the machine is out of memory
 */
charlist_t * charlist_add_char_ptr_owned(charlist_t * list, const char * str);

/**
 *free a charlist
 *@param list the list to free
 */
void charlist_free(charlist_t * list);


#endif /* IMAGE_MAP_FILE_H */

